const types = require('conventional-commit-types').types;
const message = require('@commitlint/message');

module.exports = {
  extends: ['@commitlint/config-conventional'],
  plugins: [
    {
      rules: {
        'has-jira-issue': function(parsed, when = 'always', value = 'DAZ') {
          const { subject } = parsed;
          const negated = when === 'never';
          const issueRegex = `${value}-\\d+\\s.*`;
          const matches = new RegExp(issueRegex, 'u').test(subject);

          return [
            negated !== matches,
            message([
              'subject',
              negated ? 'may not' : 'must',
              `include a JIRA-issue matching: ${value}-[0-9]+`,
            ]),
          ];
        },
      },
    },
  ],
  rules: {
    'scope-empty': [2, 'always'],
    'type-enum': [2, 'always', Object.keys(types)],
    'subject-case': [0, 'always'],
    'has-jira-issue': [2, 'always'],
  },
};
